-- Includes
require('Code/universal.lua')

Bullet = {} -- Create a table to hold the class methods

function Bullet:new(rs, sd, st, te, re, it) -- The constructor
  local object = { radius = rs, speed = sd, shot = st, time = te, rate = re, input = it }
  setmetatable(object, { __index = Bullet }) -- Inheritance
  return object
end

function Bullet:birth(ship, bullets, dt)
   if self.shot then
      self.time = self.time + dt
      if ( self.time > dt*self.rate ) then
         self.shot = false
         self.time = 0
      end
   end
   if self.input then
      if ( love.mouse.isDown('l') and self.shot == false ) then
         self:create(ship, bullets)
      end
   else
      if self.shot == false then
         self:create(ship, bullets)
      end
   end
end

function Bullet:create(ship, bullets)
   self.shot = true
   new_bullet = love.physics.newBody( world, ship:getX(), ship:getY(), 1, 0 )
   new_bullet:setBullet( true )
   new_bullet:applyImpulse( -math.sin(ship:getAngle()) * self.speed,
                            -math.cos(ship:getAngle()) * self.speed )
   table.insert( bullets, new_bullet )
   play_sound(s_shoot)
end

function Bullet:death(bullets)
   for index, bullet in ipairs(bullets) do
      local result = screen_edge( bullet:getX(), bullet:getY(), 0 )
      if ( result == 1 or result == 2 or result == 3 or result == 4 ) then
         table.remove( bullets, index )
      end
   end
end

function Bullet:draw(bullets)
   for index, bullet in ipairs(bullets) do
      love.graphics.circle("fill", bullet:getX(), bullet:getY(), self.radius, 8)
   end
end