Effect = {} -- Create a table to hold the class methods

function Effect:new(p, p_max, sd_min, sd_max, se_min, se_max, l, pl, spd, a) -- The constructor
  local object = { effect = love.graphics.newParticleSystem(p, p_max),
                   speed_min = sd_min, speed_max = sd_max, size_min = se_min, size_max = se_max,
                   life = l, particle_life = pl, spread = spd, acceleration = a }
  setmetatable(object, { __index = Effect }) -- Inheritance
  return object
end

function Effect:new_effect(p, p_max, e, c, xp, yp)
   self.effect = love.graphics.newParticleSystem(p, p_max)
   self:set_emission(e)
   self:set_colour(c)
   self:set_position(xp, yp)
   
   self.effect:setSpeed(self.speed_min, self.speed_max)
   self.effect:setSize(self.size_min, self.size_max)
   self.effect:setLifetime(self.life)
   self.effect:setParticleLife(self.particle_life)
   self.effect:setSpread(self.spread)
   self.effect:setRadialAcceleration(self.acceleration)
end

function Effect:get_effect()
   return self.effect
end
               
function Effect:set_emission(e)
   self.effect:setEmissionRate(e)
end

function Effect:set_colour(c)
   if c == 'yellow' then
      self.effect:setColor(255, 255, 0, 255, 125, 125, 0, 0)
   elseif c == 'blue' then
      self.effect:setColor(0, 0, 255, 255, 0, 0, 125, 0)
   elseif c == 'green' then
      self.effect:setColor(0, 255, 0, 255, 0, 125, 0, 0)
   elseif c == 'red' then
      self.effect:setColor(255, 0, 0, 255, 125, 0, 0, 0)
   else
      self.effect:setColor(255, 255, 255, 255, 125, 125, 125, 0)
   end
end

function Effect:set_position(xp, yp)
   self.effect:setPosition(xp, yp)
end