-- Includes
require('Code/universal.lua')
require('Code/bullet.lua')

Enemy = {} -- Create a table to hold the class methods

-- The constructor
function Enemy:new(h, d, de, b, r, s, t, c, -- Enemy itself
                   rs, sd, st, te, rt, it) -- Enemy bullet
  local object = { health = h, damage = d, d_effect = de, body = b, radius = r, speed = s, turn_speed = t,
                   colour = c, bullet = Bullet:new(rs, sd, st, te, rt, it), bullets = {} }
  setmetatable(object, { __index = Enemy }) -- Inheritance
  return object
end

function Enemy:update(dt, health, tar_x, tar_y, tar_active)
   if tar_active then
       self.body:setAngle( -turn_to_face( self.body:getX(), self.body:getY(), tar_x, tar_y,
                           self.body:getAngle(), self.turn_speed ) - (math.pi/2) )
       self.body:setX( self.body:getX() - math.sin(self.body:getAngle()) * self.speed )
       self.body:setY( self.body:getY() - math.cos(self.body:getAngle()) * self.speed )
       
       self.d_effect:start()
       self.d_effect:setEmissionRate((health - self.health) * 25)
       self.d_effect:setPosition(self.body:getX(), self.body:getY())
       self.d_effect:update(dt)
       
       self.bullet:birth(self.body, self.bullets, dt)
       self.bullet:death(self.bullets)
   end
end

function Enemy:draw()
   colour(self.colour)
   draw_ship( self.body:getX(), self.body:getY(), self.body:getAngle(), self.radius )
   love.graphics.draw(self.d_effect)
   self.bullet:draw(self.bullets)
   love.graphics.rectangle( 'fill', self.body:getX() + self.radius, self.body:getY() - self.radius,
                            self.health, 5 )
end